﻿using System;
using System.Collections.Generic;
using System.Runtime.CompilerServices;

namespace PuzzlePlayer_Namespace
{ 
    /* The binair board consist of 1 and 0
     * This means that the possible states a cell can be are: empty, one or zero
     * To specify this in an int[,] array we will use -1 for an empty space,
     * 0 for a space with a zero and 1 for a space with a one
     * The empty space is a constant defined in the abstract Board class
     */

    internal class Binair : Board
    {

        // constructor with baordSize parameter (default is set to 8 but can be changed)
        public Binair(int boardSize = 8)
        {
            // create a board with the specifide size
            boardState = new int[boardSize,boardSize];

            // clear the board (fill it in with -1)
            Clear();
        }

        private void Clear()
        {
            int size = boardState.GetLength(0);
            // fill the board with empty spaces (-1)
            for (int i = 0; i < size; i++)
            {
                for (int j = 0; j < size; j++)
                    boardState[i, j] = emptySpace;
            }
        }

        /* this static methode returns true if the board is valid in a few steps
        1: It checks if the size from boardToCheck is equal to the size from the boardState variable
        2: it loops though the board and checks if one of the spaces contains something other than a -1,0 or 1
        */
        public override bool IsBoardValid(int[,] boardToCheck)
        {
            // check if the size is NOT the same
            if(!(boardToCheck.GetLength(0) ==  boardState.GetLength(0) && boardToCheck.GetLength(1) == boardState.GetLength(1)))
                return false;
                

            // check if any of the spaces doesn't contain a -1,0 or 1
            for(int i = 0;i < boardToCheck.GetLength(0);i++)
            {
                for(int j = 0; j < boardToCheck.GetLength(1);j++)
                {
                    switch(boardToCheck[i,j])
                    {
                        case -1:
                        case 0:
                        case 1:
                            break;
                        default:
                            return false;
                    }
                }
            }

            return true;
        }

        public override void Generate()
        {
            throw new NotImplementedException();
        }

        protected override int[,] SolveStep(int[,] currentBoardState)
        {
            // list with all the possible moves
            List<int[,]> moves = new List<int[,]>();

            int[,] result = currentBoardState;

            // generate all possible moves

            //TODO
            throw new NotImplementedException();


            // if there are no moves found then null is returned
            if (moves.Count == 0)
                return null;
            
            // return one of the possible moves
            Random rnd = new Random();
            return moves[rnd.Next(0, moves.Count - 1)];
        }
    }
}
